# GridDB CE 5.0

## 主な変更点

GridDB CE V5.0の主な変更点は以下のとおりです。

### データ管理部を刷新。大規模データに対する性能強化

ロウ指向ストアだけでなく、カラム指向ストアやオブジェクトストアなど、様々なタイプのストアに将来対応可能にするためにデータ管理部を刷新しました。また、大規模データに対する以下の性能強化を行いました。

1. コアスケール対応
    - これまで並列実行数(ノード定義ファイルの/dataStore/concurrency)を変更するにはDBの再構築が必要でした。今回、ノード定義ファイルの設定変更とノード再起動により並列実行数が変更可能になりました。
2. スキャン、データ削除高速化
    - データアフィニティのヒント情報として、文字列 **#unique** を設定することで、コンテナ(テーブル)単位にブロックを占有してデータを配置することが可能になりました。これにより、スキャンやテーブル削除が高速になりました。
3. チェックポイント実行時のディスクI/O負荷低減
    - チェックポイント時のログ書き込みを分割で実行することが可能になりました。分割数は、ノード定義ファイルの/checkpoint/particalCheckpointIntervalで調整できます。デフォルトは5です。設定値を大きくすることで、チェックポイントログファイルへの1回の書き込み量を減少させることができますが、起動時のリカバリ時間が増える可能性があります。

### サーバ機能と運用ツールの追加
4. SQLによるカラム名変更
    - 以下のSQLに対応しました。

    ALTER TABLE *テーブル名* RENAME COLUMN *変更前カラム名* TO *変更後カラム名*;

5. GridDBサービス機能
    - OS起動/停止時にGridDBサーバの起動・停止が可能になりました。利用方法は[GridDB_Service_ja.md](GridDB_Service_ja.md)を参照してください。
6. [エクスポート・インポートツール](https://github.com/griddb/expimp)
    - GridDBのデータのエクスポート/インポートを行うツールを提供します。

---

## 仕様の変更点

### データベースファイルの配置

従来はdataフォルダにチェックポイントファイルとトランザクションログファイルを配置していました。

V5では以下の配置となります。

  * 従来のチェックポイントファイルは、データが書き込まれるデータファイル(拡張子:"dat")とブロック管理情報を格納するチェックポイントログファイル(拡張子:"cplog")の2つに分かれます。
  * dataフォルダにデータファイルとチェックポイントログファイル、txnlogフォルダにトランザクションログファイル(拡張子:"xlog")を配置します。
  * 更に、data、txnlogの下にパーティション単位でフォルダを作り、その下に各パーティションのファイルを配置します。

### コンフィグの追加

ノード定義ファイル(gs_node.json)に以下のコンフィグを追加します。

  * /dataStore/transactionLogPath : トランザクションログファイルのトップディレクトリ(デフォルト:”txnlog”)
  * /checkpoint/partialCheckpointInterval : チェックポイント時のログ書き込みの分割数。このチェックポイント回数で全ブロックの管理情報を記録

### 注意点

- 過去のバージョンのDBとの互換性はありません。V4のDBのデータを利用したい場合は、エクスポート・インポートツールを使用してデータを取り出し、V5のDBにデータを登録してください。
- ハッシュ索引、ロウ期限解放、時系列圧縮、トリガ機能はV5で廃止となりました。ハッシュ索引、期限解放、圧縮の機能については、ツリー索引、パーティション期限解放、ブロック圧縮で代用してください。

